//+------------------------------------------------------------------+
//|                                                      ProjectName |
//|                                      Copyright 2012, CompanyName |
//|                                       http://www.companyname.net |
//+------------------------------------------------------------------+
//Na Golici
#define __VERSION__ "1.790"

#define FOURTH_CANDLE

#property version __VERSION__
#property indicator_chart_window
#ifdef FOURTH_CANDLE
   #property indicator_buffers 8   
#else 
   #property indicator_buffers 6
#endif 
#property indicator_color1 clrLime
#property indicator_color2 clrRed

#property indicator_color3 clrBlue
#property indicator_color4 clrOrange
#property indicator_color5 clrGreen
#property indicator_color6 clrPurple

#ifdef FOURTH_CANDLE
   #property indicator_color7 clrYellow
#endif 
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
enum ARROWINDEX
  {
   FIRST=0,
   SECOND=1,
   THIRD=2,
   FOURTH=3,
   FIFTH=4,
   SIXTH=5,
   #ifdef FOURTH_CANDLE
      SEVEN=6,
      EIGHT=7,
   #endif 
  };
//+------------------------------------------------------------------+
enum SizeDecision
  {
   GREATER=0,
   LESS=1,
   BETWEEN=2
  };
//+------------------------------------------------------------------+
enum CandleDirection
  {
   BULLISH=0,
   BEARISH=1,
   ALL=2
  };
//+------------------------------------------------------------------+
enum ApplyTo
  {
   CANDLE=0,
   AVERAGE=1
  };
enum EnmCandleBType
  {
   enm_candleBType_points  = 0,  // POINTS
   enm_candleBType_average = 1,  // AVERAGE
  };
//+------------------------------------------------------------------+
enum ApplyToDetail
  {
   APPLY_FIRST_CANDLE=0,
   APPLY_SECOND_CANDLE=1,
   APPLY_AVERAGE=2,
  };
enum ApplyToWick3
  {
   APPLY_1st_CANDLE=1,
   APPLY_2nd_CANDLE=2,
   APPLY_3rd_CANDLE=3,
   APPLY_AVE=0,  
  };
//+------------------------------------------------------------------+
enum ApplyOptionsForCandle2Body
  {
   FIRST_CANDLE_FOR_CANDLE2=0,
   AVERAGE_FOR_CANDLE2=1
  };
enum ApplyOptionsForCandle3Body
  {
   FIRST_CANDLE_FOR_CANDLE3=1,
   SECOND_CANDLE_FOR_CANDLE3=2,
   AVERAGE_FOR_CANDLE3=0,
  };
//+------------------------------------------------------------------+
  enum ApplyOptionsForHighestLowest
  {
   HIGHEST=0,
   LOWEST=1
  };
enum EnmShowSignals
  {
   enm_show_1 = 1,      //signal#1
   enm_show_2 = 2,      //signal#2
   enm_show_3 = 4,      //signal#3
   enm_show_12= 3,      //signal#12
   enm_show_13= 5,      //signal#13
   enm_show_23= 6,      //signal#23
   enm_show_123=7,      //signal#123
   
   #ifdef FOURTH_CANDLE
      enm_show_4=8,     //signal#4
      enm_show_14=9,    //signal#14
      enm_show_24=10,   //signal#23
      enm_show_34=12,   //signal#34
      enm_show_124=11,  //signal#124
      enm_show_134=13,  //signal#134
      enm_show_234=14,  //signal#234
      enm_show_1234=15, //signal#1234
   #endif    
   //---
   //1: 1,3,5,7,9,11,13,15 %2>=1
   //2: 2,3,6,7,10,11,14,15 %4>=2
   //3: 4,5,6,7,12,13,14,15 %8>=4
   //4: 8-15  >=8
   
  };
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
struct SCandlePoints
  {
   double   points;
   double   between;
   SizeDecision decision;
   void Init(const double _points,const double _between,const SizeDecision _decision)
     {
      this.points=_points;
      this.between=_between;
      this.decision=_decision;
     }
  };
SCandlePoints getCandlePoints(const double _points,const double _between,const SizeDecision _decision)
  {
   SCandlePoints result;
   result.Init(_points,_between,_decision);
   return result;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
extern bool activate1CandlePattern=true;           //activate1CandlePattern REMOVE??
extern bool activate2CandlePattern=true;           //activate2CandlePattern REMOVE??
extern bool activate3CandlePattern=true;           //activate3CandlePattern REMOVE??
//extern bool specialShow=false;
input  EnmShowSignals showSignal=7;                // show signals
extern bool activate1CandleCaseA_Template1=true;
extern bool activate2CandleCaseA_Template3=true;
extern bool activate1CandleCaseB_Template2=true;
extern bool activate2CandleCaseB_Template4=true;
extern bool activate3CandleCaseA_Template5=true;
extern bool activate3CandleCaseB_Template6=true;
extern bool activate5thParameter=true;
extern string separator0="-----------------------------------------------------";
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
extern CandleDirection firstCandleDirection_Template1=BULLISH;

extern double firstCandleBodyPoints_Template1=10;
extern double firstCandleBodyBetweenPoints_Template1=10;
extern SizeDecision firstCandleBodyDecision_Template1=GREATER;

extern double firstCandleUpperWickPoints_Template1=10;
extern double firstCandleUpperWickBetweenPoints_Template1=20;
extern SizeDecision firstCandleUpperWickDecision_Template1=GREATER;

extern double firstCandleLowerWickPoints_Template1=10;
extern double firstCandleLowerWickBetweenPoints_Template1=20;
extern SizeDecision firstCandleLowerWickDecision_Template1=GREATER;
extern string separator="-----------------------------------------------------";
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
extern CandleDirection secondCandleDirection_Template3=BULLISH;

extern double secondCandleBodyPoints_Template3=10;
extern double secondCandleBodyBetweenPoints_Template3=10;
extern SizeDecision secondCandleBodyDecision_Template3=GREATER;

extern double secondCandleUpperWickPoints_Template3=10;
extern double secondCandleUpperWickBetweenPoints_Template3=20;
extern SizeDecision secondCandleUpperWickDecision_Template3=GREATER;

extern double secondCandleLowerWickPoints_Template3=10;
extern double secondCandleLowerWickBetweenPoints_Template3=20;
extern SizeDecision secondCandleLowerWickDecision_Template3=GREATER;
extern string separator1="-----------------------------------------------------";
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
extern CandleDirection thirdCandleDirection_Template5=BULLISH;

extern double thirdCandleBodyPoints_Template5=10;
extern double thirdCandleBodyBetweenPoints_Template5=10;
extern SizeDecision thirdCandleBodyDecision_Template5=GREATER;

extern double thirdCandleUpperWickPoints_Template5=10;
extern double thirdCandleUpperWickBetweenPoints_Template5=20;
extern SizeDecision thirdCandleUpperWickDecision_Template5=GREATER;

extern double thirdCandleLowerWickPoints_Template5=10;
extern double thirdCandleLowerWickBetweenPoints_Template5=20;
extern SizeDecision thirdCandleLowerWickDecision_Template5=GREATER;
extern string separator11="-----------------------------------------------------";
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
input EnmCandleBType firstCandleBBodyType_Template2=0;
input  double firstCandleBBodyTypePoints_Template2=10;
extern int firstCandleBodyAverageCandleAmount_Template2=10;


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
extern CandleDirection firstCandleDirection_Template2=BULLISH;

extern double firstCandleBodyPercent_Template2=1;
extern double firstCandleBodyPercentBetween_Template2=2;
extern SizeDecision firstCandleBodyDecision_Template2=GREATER;

extern ApplyTo appyToUpperWickTemplate2=CANDLE;
extern double firstCandleUpperWickPercent_Template2=0.10;
extern double firstCandleUpperWickBetweenPercent_Template2=0.20;
extern SizeDecision firstCandleUpperWickDecision_Template2=GREATER;

extern ApplyTo appyToLowerWickTemplate2=CANDLE;
extern double firstCandleLowerWickPercent_Template2=0.10;
extern double firstCandleLowerWickBetweenPercent_Template2=0.20;
extern SizeDecision firstCandleLowerWickDecision_Template2=GREATER;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
extern string separator2="-----------------------------------------------------";


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+


extern CandleDirection secondCandleDirection_Template4=BULLISH;

extern ApplyOptionsForCandle2Body applyToBody_Template4 = FIRST_CANDLE_FOR_CANDLE2;
extern double secondCandleBodyPercent_Template4=1;
extern double secondCandleBodyPercentBetween_Template4=2;
extern SizeDecision secondCandleBodyDecision_Template4=GREATER;

extern ApplyToDetail appyToUpperWickTemplate4=APPLY_FIRST_CANDLE;
extern double secondCandleUpperWickPercent_Template4=0.10;
extern double secondCandleUpperWickBetweenPercent_Template4=0.20;
extern SizeDecision secondCandleUpperWickDecision_Template4=GREATER;

extern ApplyToDetail appyToLowerWickTemplate4=APPLY_FIRST_CANDLE;
extern double secondCandleLowerWickPercent_Template4=0.10;
extern double secondCandleLowerWickBetweenPercent_Template4=0.20;
extern SizeDecision secondCandleLowerWickDecision_Template4=GREATER;

extern string separator3="-----------------------------------------------------";

extern CandleDirection thirdCandleDirection_Template6=BULLISH;

extern ApplyOptionsForCandle3Body applyToBody_Template6 = FIRST_CANDLE_FOR_CANDLE3;
extern double thirdCandleBodyPercent_Template6=1;
extern double thirdCandleBodyPercentBetween_Template6=2;
extern SizeDecision thirdCandleBodyDecision_Template6=GREATER;
//
extern ApplyToWick3 appyToUpperWickTemplate6=APPLY_1st_CANDLE;
extern double thirdCandleUpperWickPercent_Template6=0.10;
extern double thirdCandleUpperWickBetweenPercent_Template6=0.20;
extern SizeDecision thirdCandleUpperWickDecision_Template6=GREATER;
//
extern ApplyToWick3 appyToLowerWickTemplate6=APPLY_1st_CANDLE;
extern double thirdCandleLowerWickPercent_Template6=0.10;
extern double thirdCandleLowerWickBetweenPercent_Template6=0.20;
extern SizeDecision thirdCandleLowerWickDecision_Template6=GREATER;

extern string separator4="-----------------------------------------------------";
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
extern ApplyOptionsForHighestLowest fifthParameter= HIGHEST;
extern int amountOfCandles = 10;


#ifdef FOURTH_CANDLE
   input CandleDirection Inp4Dir = ALL;         // candle 4 direction
   input double          Inp4Value = 0.;        // filter for ALL mode
#endif 



//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double ExtMapBuffer0_A11[];
double ExtMapBuffer1_B12[];
double ExtMapBuffer2_A23[];
double ExtMapBuffer3_B24[];
double ExtMapBuffer4_A35[];
double ExtMapBuffer5_B36[];
#ifdef FOURTH_CANDLE
   double ExtMapBuffer6_4[];
   double IntBufferA35[];
   double IntBufferB36[];
#endif 

double IntBufferA11[];
double IntBufferB12[];
double IntBufferA23[];
double IntBufferB24[];

double o, SHIFT;
SCandlePoints A11Body,A11Upper,A11Lower;
SCandlePoints A23Body,A23Upper,A23Lower;
SCandlePoints A35Body,A35Upper,A35Lower;
SCandlePoints A4Body,ABnull;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int OnInit()
  {
   o=_Point/2.;
   SHIFT=10*pow(0.1,_Digits);
//---
   if(activate1CandleCaseA_Template1)
     {
      A11Body.Init (firstCandleBodyPoints_Template1,firstCandleBodyBetweenPoints_Template1,firstCandleBodyDecision_Template1);
      A11Upper.Init(firstCandleUpperWickPoints_Template1,firstCandleUpperWickBetweenPoints_Template1,firstCandleUpperWickDecision_Template1);
      A11Lower.Init(firstCandleLowerWickPoints_Template1,firstCandleLowerWickBetweenPoints_Template1,firstCandleLowerWickDecision_Template1);


      if(activate2CandleCaseA_Template3)
        {
         A23Body.Init(secondCandleBodyPoints_Template3,secondCandleBodyBetweenPoints_Template3,secondCandleBodyDecision_Template3);
         A23Upper.Init(secondCandleUpperWickPoints_Template3,secondCandleUpperWickBetweenPoints_Template3,secondCandleUpperWickDecision_Template3);
         A23Lower.Init(secondCandleLowerWickPoints_Template3,secondCandleLowerWickBetweenPoints_Template3,secondCandleLowerWickDecision_Template3);

         if(activate3CandleCaseA_Template5)
           {
            A35Body.Init(thirdCandleBodyPoints_Template5,thirdCandleBodyBetweenPoints_Template5,thirdCandleBodyDecision_Template5);
            A35Upper.Init(thirdCandleUpperWickPoints_Template5,thirdCandleUpperWickBetweenPoints_Template5,thirdCandleUpperWickDecision_Template5);
            A35Lower.Init(thirdCandleLowerWickPoints_Template5,thirdCandleLowerWickBetweenPoints_Template5,thirdCandleLowerWickDecision_Template5);//FIXED
           }
        }
     }
//---
   int indyBuffer=0;
#ifdef FOURTH_CANDLE
   IndicatorBuffers(13);
   ABnull.Init(0,0,GREATER);

   A4Body.Init(Inp4Value,0,GREATER);
#else 
   IndicatorBuffers(10);
#endif 
   SetIndexStyle(indyBuffer,DRAW_ARROW,EMPTY,1);
   SetIndexArrow(indyBuffer,172);
   SetIndexBuffer(indyBuffer,ExtMapBuffer0_A11);
   SetIndexLabel(indyBuffer++,"act.1 CaseA_Tpl1");

   SetIndexStyle(indyBuffer,DRAW_ARROW,EMPTY,1);
   SetIndexArrow(indyBuffer,172);
   SetIndexBuffer(indyBuffer,ExtMapBuffer1_B12);
   SetIndexLabel(indyBuffer++,"act.1 CaseB_Tpl2");

   SetIndexStyle(indyBuffer,DRAW_ARROW,EMPTY,1);
   SetIndexArrow(indyBuffer,172);
   SetIndexBuffer(indyBuffer,ExtMapBuffer2_A23);
   SetIndexLabel(indyBuffer++, "act.2 CaseA_Tpl3");

   SetIndexStyle(indyBuffer,DRAW_ARROW,EMPTY,1);
   SetIndexArrow(indyBuffer,172);
   SetIndexBuffer(indyBuffer,ExtMapBuffer3_B24);
   SetIndexLabel(indyBuffer++, "act.2 CaseB_Tpl4");

   SetIndexStyle(indyBuffer,DRAW_ARROW,EMPTY,1);
   SetIndexArrow(indyBuffer,172);
   SetIndexBuffer(indyBuffer,ExtMapBuffer4_A35);
   SetIndexLabel(indyBuffer++, "act.3 CaseA_Tpl5_");

   SetIndexStyle(indyBuffer,DRAW_ARROW,EMPTY,1);
   SetIndexArrow(indyBuffer,172);
   SetIndexBuffer(indyBuffer,ExtMapBuffer5_B36);
   SetIndexLabel(indyBuffer++, "act.3 CaseB_Tpl6_");

#ifdef FOURTH_CANDLE
   SetIndexStyle(indyBuffer,DRAW_ARROW,EMPTY,1);
   SetIndexArrow(indyBuffer,172);
   SetIndexBuffer(indyBuffer,ExtMapBuffer6_4);
   SetIndexLabel(indyBuffer++, "act.4");
#endif 

   SetIndexBuffer(indyBuffer++,IntBufferA11,INDICATOR_CALCULATIONS);
   SetIndexBuffer(indyBuffer++,IntBufferB12,INDICATOR_CALCULATIONS);
   SetIndexBuffer(indyBuffer++,IntBufferA23,INDICATOR_CALCULATIONS);
   SetIndexBuffer(indyBuffer++,IntBufferB24,INDICATOR_CALCULATIONS);

#ifdef FOURTH_CANDLE
   SetIndexBuffer(indyBuffer++,IntBufferA35,INDICATOR_CALCULATIONS);
   SetIndexBuffer(indyBuffer++,IntBufferB36,INDICATOR_CALCULATIONS);
#endif 
//---
   printf("%i %s: version=%s.buffers=%d",__LINE__,__FILE__,__VERSION__,indyBuffer);
   return INIT_SUCCEEDED;
  }
#undef __VERSION__
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//int deinit()
void OnDeinit(const int reason)
  {

  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//#define debug (iTime(_Symbol,0,1)>=D'2020.05.01 17:58:00' && iTime(_Symbol,0,1)<D'2020.05.01 17:59:59')
#define debug (false)
void start()
  {
   const int idx=1;
   if(activate1CandlePattern)
     {
      act1At1(idx);
      act1Bt2(idx);

      if(activate2CandlePattern)
        {
         act2At3(idx);
         act2Bt4(idx);
         
         if(activate3CandlePattern)
           {
            act3At5(idx);
            act3Bt6(idx);
            
            #ifdef FOURTH_CANDLE
               act4(idx);
            #endif 
           }
        }
     }
   //Comment(ExtMapBuffer0_A11[2]+" "+ExtMapBuffer1_B12[2]+IntBufferA11[2]+" "+IntBufferB12[2]);
  }
//+------------------------------------------------------------------+
void act1At1(const int shift=1)  //activate1CandleCaseA_Template1
  {
   if(!activate1CandleCaseA_Template1)
      return;
   if(!isCandleDirectionCorrect(firstCandleDirection_Template1,shift))
      return;
   calculateIfArrowHappensPoints(A11Body,A11Upper,A11Lower,shift,FIRST);
  }
void act2At3(const int shift=1)  //activate2CandleCaseA_Template3
  {
   if(!activate2CandleCaseA_Template3)
      return;
   if(!activate1CandleCaseA_Template1)
      return;
   if(IntBufferA11[shift+1]==EMPTY_VALUE)
      return;
   if(!isCandleDirectionCorrect(secondCandleDirection_Template3,shift))
      return;
   calculateIfArrowHappensPoints(A23Body,A23Upper,A23Lower,shift,THIRD);
  }
void act3At5(const int shift=1)  //activate3CandleCaseA_Template5
  {
   if(!activate3CandleCaseA_Template5)
      return;
   if(!activate2CandleCaseA_Template3)
      return;
   if(!activate1CandleCaseA_Template1)
      return;
   if(IntBufferA23[shift+1]==EMPTY_VALUE)
      return;
   if(!isCandleDirectionCorrect(thirdCandleDirection_Template5,shift))
      return;
   calculateIfArrowHappensPoints(A35Body,A35Upper,A35Lower,shift,FIFTH);
  }
#ifdef FOURTH_CANDLE
void act4(const int shift=1)
  {
   if(activate3CandleCaseA_Template5 && activate2CandleCaseA_Template3 && activate1CandleCaseA_Template1)
     {
      if(IntBufferA35[shift+1]==EMPTY_VALUE)
         return;
      if(!isCandleDirectionCorrect(Inp4Dir,shift))
         return;
      calculateIfArrowHappensPoints(A4Body,ABnull,ABnull,shift,SEVEN);
     }
   if(activate3CandleCaseB_Template6 && activate2CandleCaseB_Template4 && activate1CandleCaseB_Template2)
     {
      if(IntBufferB36[shift+1]==EMPTY_VALUE)
         return;
      if(!isCandleDirectionCorrect(Inp4Dir,shift))
         return;
      calculateIfArrowHappensPoints(A4Body,ABnull,ABnull,shift,EIGHT);
     }
  }
#endif
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double computeCandleBPoints(const int candleId,const int shift=1)//TODO: probably need to remove this function
  {
   switch(candleId)
     {
      default:
      case 1:
        {
         switch(firstCandleBBodyType_Template2)
           {
            default:
            case enm_candleBType_points:
               return firstCandleBBodyTypePoints_Template2;
            case enm_candleBType_average:
               return calculateAverage(firstCandleBodyAverageCandleAmount_Template2,shift);
           }
        }
      //TODO:
      case 2:
         return 0;
      case 3:
         return 0;
     }
  }
void act1Bt2(const int shift=1)  //activate1CandleCaseB_Template2
  {
   if(!activate1CandleCaseB_Template2)
      return;
   if(!isCandleDirectionCorrect(firstCandleDirection_Template2,shift))
      return;
   const double
      calculatedBodyAverage=calculateAverage(firstCandleBodyAverageCandleAmount_Template2,shift),
      bodyActual=sizeOfCandleBody(shift);
   const double 
      body        =firstCandleBBodyType_Template2==enm_candleBType_average?   calculatedBodyAverage:  firstCandleBBodyTypePoints_Template2,
      upperWick   =(appyToUpperWickTemplate2     ==AVERAGE?                   calculatedBodyAverage:  bodyActual),
      lowerWick   =(appyToLowerWickTemplate2     ==AVERAGE?                   calculatedBodyAverage:  bodyActual),
      bodyMax     =firstCandleBodyPercentBetween_Template2     *  body,
      bodyMin     =firstCandleBodyPercent_Template2            *  body,
      upperWickMax=firstCandleUpperWickBetweenPercent_Template2*  upperWick,
      upperWickMin=firstCandleUpperWickPercent_Template2       *  upperWick,
      lowerWickMax=firstCandleLowerWickBetweenPercent_Template2*  lowerWick,
      lowerWickMin=firstCandleLowerWickPercent_Template2       *  lowerWick;
   calculateIfArrowHappensPoints(
      getCandlePoints(bodyMin,     bodyMax,     firstCandleBodyDecision_Template2),
      getCandlePoints(upperWickMin,upperWickMax,firstCandleUpperWickDecision_Template2),
      getCandlePoints(lowerWickMin,lowerWickMax,firstCandleLowerWickDecision_Template2),
      shift,SECOND);
  }
void act2Bt4(const int shift=1)     //activate2CandleCaseB_Template4
  {
   if(!activate2CandleCaseB_Template4)
      return;
   if(!activate1CandleCaseB_Template2)
      return;
   if(IntBufferB12[shift+1]==EMPTY_VALUE)
      return;
   if(!isCandleDirectionCorrect(secondCandleDirection_Template4,shift))
      return;

   const double 
      bodyActualFirst=sizeOfCandleBody(shift+1), 
      bodyActual=sizeOfCandleBody(shift),
      // !!! ALERT ! this section down the function is updated in the indicator only
      calculatedBodyAverage=calculateAverage(firstCandleBodyAverageCandleAmount_Template2,shift+1),
      //calculatedBodyAverage=applyToBody_Template4==AVERAGE_FOR_CANDLE2 ? 
      //   //computeCandleBPoints(1,shift+1)
      //   calculateAverage(firstCandleBodyAverageCandleAmount_Template2,shift+1) : bodyActualFirst;
      candleBody = applyToBody_Template4==AVERAGE_FOR_CANDLE2 ? calculatedBodyAverage : bodyActualFirst;
   double   upperWickMax,  upperWickMin, lowerWickMin, lowerWickMax;
   switch(appyToUpperWickTemplate4)
     {
      case APPLY_AVERAGE:
        {
         upperWickMin=calculatedBodyAverage*secondCandleUpperWickPercent_Template4;
	      upperWickMax=calculatedBodyAverage*secondCandleUpperWickBetweenPercent_Template4;
         break;
        }
      case APPLY_SECOND_CANDLE:
        {
         upperWickMin=bodyActual*secondCandleUpperWickPercent_Template4;
         upperWickMax=bodyActual*secondCandleUpperWickBetweenPercent_Template4;
         break;
        }
      case APPLY_FIRST_CANDLE:
        {
         upperWickMin=bodyActualFirst*secondCandleUpperWickPercent_Template4;
         upperWickMax=bodyActualFirst*secondCandleUpperWickBetweenPercent_Template4;
         break;
        }
     }
   switch(appyToLowerWickTemplate4)
     {
      case APPLY_AVERAGE:
        {
         lowerWickMin=calculatedBodyAverage*secondCandleLowerWickPercent_Template4;
         lowerWickMax=calculatedBodyAverage*secondCandleLowerWickBetweenPercent_Template4;
         break;
        }
      case APPLY_SECOND_CANDLE:
        {
         lowerWickMin=bodyActual*secondCandleLowerWickPercent_Template4;
         lowerWickMax=bodyActual*secondCandleLowerWickBetweenPercent_Template4;
         break;
        }
      case APPLY_FIRST_CANDLE:
        {
         lowerWickMin=bodyActualFirst*secondCandleLowerWickPercent_Template4;
         lowerWickMax=bodyActualFirst*secondCandleLowerWickBetweenPercent_Template4;
         break;
        }
     }
   calculateIfArrowHappensPoints(
      getCandlePoints(candleBody*secondCandleBodyPercent_Template4,candleBody*secondCandleBodyPercentBetween_Template4,secondCandleBodyDecision_Template4),
      getCandlePoints(upperWickMin,upperWickMax,secondCandleUpperWickDecision_Template4),
      getCandlePoints(lowerWickMin,lowerWickMax,secondCandleLowerWickDecision_Template4),
      shift,FOURTH);
  }
void act3Bt6(const int shift=1)
  {
   if(!activate3CandleCaseB_Template6)
      return;
   if(!activate2CandleCaseB_Template4)
      return;
   if(!activate1CandleCaseB_Template2)
      return;
   if(IntBufferB24[shift+1]==EMPTY_VALUE)
      return;
   if(!isCandleDirectionCorrect(thirdCandleDirection_Template6,shift))
      return;
   const double 
      bodyActualFirstBack=sizeOfCandleBody(shift+1),
      bodyActualSecondBack=sizeOfCandleBody(shift+2), 
      bodyActual=sizeOfCandleBody(shift),
      average=
         //computeCandleBPoints(1,shift+2);
         calculateAverage(firstCandleBodyAverageCandleAmount_Template2,shift+2);

   double candleBody=0;
   switch(applyToBody_Template6)
     {
      case AVERAGE_FOR_CANDLE3:
         candleBody=average;
         //calculateAverage(firstCandleBodyAverageCandleAmount_Template2,shift+2);
         break;
      case FIRST_CANDLE_FOR_CANDLE3:
         candleBody=bodyActualSecondBack;
         break;
      case SECOND_CANDLE_FOR_CANDLE3:
         candleBody=bodyActualFirstBack;
         break;
     }
   double   upperWickMax,  upperWickMin, lowerWickMin, lowerWickMax;
   switch(appyToUpperWickTemplate6)
     {
      case APPLY_AVE:
        {
         upperWickMin=average*thirdCandleUpperWickPercent_Template6;
	      upperWickMax=average*thirdCandleUpperWickBetweenPercent_Template6;
         break;
        }
      case APPLY_3rd_CANDLE:
        {
         upperWickMin=bodyActual*thirdCandleUpperWickPercent_Template6;
         upperWickMax=bodyActual*thirdCandleUpperWickBetweenPercent_Template6;
         break;
        }
      case APPLY_2nd_CANDLE:
        {
         upperWickMin=bodyActualFirstBack*thirdCandleUpperWickPercent_Template6;
         upperWickMax=bodyActualFirstBack*thirdCandleUpperWickBetweenPercent_Template6;
         break;
        }
      case APPLY_1st_CANDLE:
        {
         upperWickMin=bodyActualSecondBack*thirdCandleUpperWickPercent_Template6;
         upperWickMax=bodyActualSecondBack*thirdCandleUpperWickBetweenPercent_Template6;
         break;         
        }
     }
   switch(appyToLowerWickTemplate6)
     {
      case APPLY_AVE:
        {
         lowerWickMin=average*thirdCandleLowerWickPercent_Template6;
         lowerWickMax=average*thirdCandleLowerWickBetweenPercent_Template6;
         break;
        }
      case APPLY_3rd_CANDLE:
        {
         lowerWickMin=bodyActual*thirdCandleLowerWickPercent_Template6;
         lowerWickMax=bodyActual*thirdCandleLowerWickBetweenPercent_Template6;
         break;
        }
      case APPLY_2nd_CANDLE:
        {
         lowerWickMin=bodyActualFirstBack*thirdCandleLowerWickPercent_Template6;
         lowerWickMax=bodyActualFirstBack*thirdCandleLowerWickBetweenPercent_Template6;
         break;
        }
      case APPLY_1st_CANDLE:
        {
         lowerWickMin=bodyActualSecondBack*thirdCandleLowerWickPercent_Template6;
         lowerWickMax=bodyActualSecondBack*thirdCandleLowerWickBetweenPercent_Template6;
         break;
        }
     }
   calculateIfArrowHappensPoints(
      getCandlePoints(candleBody*thirdCandleBodyPercent_Template6,candleBody*thirdCandleBodyPercentBetween_Template6,thirdCandleBodyDecision_Template6),
      getCandlePoints(upperWickMin,upperWickMax,thirdCandleUpperWickDecision_Template6),
      getCandlePoints(lowerWickMin,lowerWickMax,thirdCandleLowerWickDecision_Template6),
      shift,SIXTH);
  }
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|              16.03.2019                                                    |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool isCandleDirectionCorrect(const CandleDirection firstCandleDirection,const int counter)
  {
   const int directionOfCandle=directionOfCandle(counter);
   bool directionAllowed=true;
   switch(firstCandleDirection)
     {
      case ALL:      break;
      case BULLISH:  directionAllowed=(directionOfCandle==1);  break;
      case BEARISH:  directionAllowed=(directionOfCandle==-1); break;
     }
   return directionAllowed;  
  }
//+------------------------------------------------------------------+
//|              16.03.2019                                                    |
//+------------------------------------------------------------------+
void calculateIfArrowHappensPoints(SCandlePoints &body,SCandlePoints &upper,SCandlePoints &lower,const int counter,const ARROWINDEX arrowIndex)
  {
   if(!doesItSuitPoints(sizeOfCandleBody(counter),body))
      return;
   if(!doesItSuitPoints(sizeOfLowerWick(counter),lower))
      return;
   if(!doesItSuitPoints(sizeOfUpperWick(counter),upper))
      return;

   switch(arrowIndex)
     {
      case FIRST:
        {
         if(fifthRule(counter,counter))
           {
            IntBufferA11[counter]=High[counter]+SHIFT;
            if(showSignal%2>=1)
               ExtMapBuffer0_A11[counter]=IntBufferA11[counter];
            printf("%i %s: first=%s %d %d",__LINE__,__FILE__,TimeToString(iTime(_Symbol,0,counter)),showSignal,showSignal%2);
           }
         break;
        }
      case SECOND:
        {
         if(fifthRule(counter,counter))
           {
            IntBufferB12[counter]=High[counter]+SHIFT;
            if(showSignal%2>=1)
               ExtMapBuffer1_B12[counter]=IntBufferB12[counter]+SHIFT;
            printf("%i %s: second=%s %d %d",__LINE__,__FILE__,TimeToString(iTime(_Symbol,0,counter)),showSignal,showSignal%2);
           }
        
         break;
        }
      case THIRD:
        {
         if(fifthRule(counter,counter+1))
           {
            IntBufferA23[counter]=High[counter]+SHIFT;
            if(showSignal%4>=2)
            	ExtMapBuffer2_A23[counter]=IntBufferA23[counter]+2*SHIFT;
            printf("%i %s: 3rd=%s %d %d",__LINE__,__FILE__,TimeToString(iTime(_Symbol,0,counter)),showSignal,showSignal%4);
           }
         break;
        }
      case FOURTH:
        {
         if(fifthRule(counter,counter+1))
           {
            IntBufferB24[counter]=High[counter]+SHIFT;
            if(showSignal%4>=2)
               ExtMapBuffer3_B24[counter]=IntBufferB24[counter]+3*SHIFT;
            printf("%i %s: fourth=%s %d %d",__LINE__,__FILE__,TimeToString(iTime(_Symbol,0,counter)),showSignal,showSignal%4);
           }
         break;
        }
      case FIFTH:
        {
         if(fifthRule(counter,counter+2))
           {
            IntBufferA35[counter]=High[counter]+5*SHIFT;
            if(showSignal%8>=4)
               ExtMapBuffer4_A35[counter]=IntBufferA35[counter];
            printf("%i %s: fifth=%s %d %d",__LINE__,__FILE__,TimeToString(iTime(_Symbol,0,counter)),showSignal,showSignal>=4);
           }
         break;
        }
      case SIXTH:
        {

         if(fifthRule(counter,counter+2))
           {
            IntBufferB36[counter]=High[counter]+6*SHIFT;
            if(showSignal%8>=4)
               ExtMapBuffer5_B36[counter]=High[counter];
            printf("%i %s: sixth=%s %d %d",__LINE__,__FILE__,TimeToString(iTime(_Symbol,0,counter)),showSignal,showSignal>=4);
           }
         break;
        }
#ifdef FOURTH_CANDLE
      case SEVEN:
        {
         if(showSignal%16>=8)
            ExtMapBuffer6_4[counter]=High[counter]+10*SHIFT;
         printf("%i %s: 7th=%s %d %d",__LINE__,__FILE__,TimeToString(iTime(_Symbol,0,counter)),showSignal,showSignal>=4);
         break;
        }
      case EIGHT:
        {
         if(showSignal%16>=8)
            ExtMapBuffer6_4[counter]=High[counter]+10*SHIFT;
         printf("%i %s: 8th=%s %d %d",__LINE__,__FILE__,TimeToString(iTime(_Symbol,0,counter)),showSignal,showSignal>=4);
         //---
         break;
        }
#endif 
      default:
         break;
     }
  }
//+------------------------------------------------------------------+
//|              16.03.2019                                                    |
//+------------------------------------------------------------------+
double calculateAverage(int total,int indexNumber)
  {
   double totalAverageNumber=0;
   for(int counter=1;counter<=total;counter++)
     {
      //TODO: probably need to have (high-low)/_Point only
      double candleBody=sizeOfCandleBody(indexNumber+counter);
      double candleLower = sizeOfLowerWick(indexNumber+counter);
      double candleUpper = sizeOfUpperWick(indexNumber+counter);
      totalAverageNumber=totalAverageNumber+candleBody+candleLower+candleUpper;
     }
   return totalAverageNumber/total;
  }
//+------------------------------------------------------------------+
//|            DEFAULT CALCULATIONS                             	 |
//+------------------------------------------------------------------+
bool  doesItSuitPoints(const double actualSize,const SCandlePoints &candle)
  {
   switch(candle.decision)
     {
      case GREATER:
         return actualSize-candle.points>-o/10;
      case LESS:
         return candle.points-actualSize>-o/10;
      case BETWEEN:
         return candle.between-actualSize>-o/10 && actualSize-candle.points>-o/10;
      default:
         return false;
     }
  }
//+------------------------------------------------------------------+
int directionOfCandle(const int counter)
  {
   const double close=iClose(_Symbol,0,counter), open=iOpen(_Symbol,0,counter);
   int result=0;
   if(close-open>o)
      result=1;
   else if(open-close>o)
      result=-1;
   return result;
  }
//+------------------------------------------------------------------+
int sizeOfCandleBody(int counter)
  {
   return (int)NormalizeDouble(fabs(iClose(_Symbol,0,counter)-iOpen(_Symbol,0,counter))/_Point,0);
  }
//+------------------------------------------------------------------+
int sizeOfUpperWick(const int counter)
  {
   return (int)NormalizeDouble((iHigh(_Symbol,0,counter)-fmax(iClose(_Symbol,0,counter),iOpen(_Symbol,0,counter)))/_Point,0);
  }
//+------------------------------------------------------------------+
int sizeOfLowerWick(int counter)
  {
   return (int)NormalizeDouble((fmin(iClose(_Symbol,0,counter),iOpen(_Symbol,0,counter))-iLow(_Symbol,0,counter) )/_Point,0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool fifthRule(const int shift,const int starts)
  {
	if(!activate5thParameter)
		return true;
   switch(fifthParameter)
     {
      default:
         return true;
      case HIGHEST:
        {
         const double valueHigh=fmax(iOpen(_Symbol,0,iHighest(_Symbol,0,MODE_OPEN,amountOfCandles,starts+1)),
                                    iClose(_Symbol,0,iHighest(_Symbol,0,MODE_CLOSE,amountOfCandles,starts+1)));
         return iHigh(_Symbol,0,shift)-valueHigh>0;//TODO: not shift, but highest of last X?
        }
      case LOWEST:
        {
         const double valueLow=fmin(iOpen(_Symbol,0,iLowest(_Symbol,0,MODE_OPEN,amountOfCandles,starts+1)),
                                    iClose(_Symbol,0,iLowest(_Symbol,0,MODE_CLOSE,amountOfCandles,starts+1)));
         return valueLow-iLow(_Symbol,0,shift)>0;
        }
     }
  }
////+------------------------------------------------------------------+